Kea: isc::dhcp::PoolsListParser Class Reference

| Kea 2.2.0

Public Member Functions | Protected Member Functions | List of all members
isc::dhcp::PoolsListParser Class Referenceabstract

Parser for a list of pools. More...

`#include <dhcp_parsers.h>`

Inheritance diagram for isc::dhcp::PoolsListParser:
[legend]

## Public Member Functions
virtual | ~PoolsListParser ()
| destructor. More...
virtual void | parse (PoolStoragePtr pools, isc::data::ConstElementPtr pools_list)=0
| parses the actual structure More...
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t. More...
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t. More...
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value. More...
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet. More...

## Protected Member Functions
virtual boost::shared_ptr< PoolParser > | createPoolConfigParser () const =0
| Returns an instance of the `PoolParser` to be used in parsing the address pools. More...
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type , target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope. More...
template<typename int_type >
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope. More...

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type. More...
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present. More...
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child. More...
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope. More...
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope. More...
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range. More...
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element. More...
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope. More...
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values. More...
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list. More...

## Detailed Description

Parser for a list of pools.

This parser parses a list pools. Each element on that list gets its own parser, created with poolParserMaker() method. That method must be specified for each protocol family (v4 or v6) separately.

Definition at line 379 of file dhcp_parsers.h.

## Constructor & Destructor Documentation

## ◆ ~PoolsListParser()

virtual isc::dhcp::PoolsListParser::~PoolsListParser | ( |  | ) |
| inlinevirtual

destructor.

Definition at line 383 of file dhcp_parsers.h.

## Member Function Documentation

## ◆ createPoolConfigParser()

virtual boost::shared_ptr< PoolParser > isc::dhcp::PoolsListParser::createPoolConfigParser | ( |  | ) | const
| protectedpure virtual

Returns an instance of the `PoolParser` to be used in parsing the address pools.

This function can be overridden in the child classes to supply a custom parser for the pools.

Returns
  an instance of the `PoolParser`.

Implemented in isc::dhcp::Pools4ListParser, and isc::dhcp::Pools6ListParser.

## ◆ parse()

virtual void isc::dhcp::PoolsListParser::parse | ( | PoolStoragePtr | pools,
|  | isc::data::ConstElementPtr | pools_list
| ) |  |
| pure virtual

parses the actual structure

This method parses the actual list of pools.

Parameters

  pools | is the storage in which to store the parsed pools.
  pools_list | a list of pool structures

Exceptions

  isc::dhcp::DhcpConfigError | when pool parsing fails

Implemented in isc::dhcp::Pools4ListParser, and isc::dhcp::Pools6ListParser.

The documentation for this class was generated from the following file:

- dhcp_parsers.h